/*
 CPLD Logic Analyser
 Version: 0.1
 Author: Alex from insideGadgets (www.insidegadgets.com)
 Created: 12/12/2013
 Last Modified: 12/12/2013
 
 */

#ifndef cbi
#define cbi(sfr, bit) (_SFR_BYTE(sfr) &= ~_BV(bit))
#endif
#ifndef sbi
#define sbi(sfr, bit) (_SFR_BYTE(sfr) |= _BV(bit))
#endif

#ifndef boolean
	typedef uint8_t boolean;
#endif
#ifndef bool
	typedef uint8_t bool;
#endif 
#ifndef byte
	typedef uint8_t byte;
#endif

#ifndef NULL
#define NULL ((void *)0)
#endif

#define LOW 0
#define HIGH 1
#define false 0
#define true 1

void setup(void) {
	// SPI setup
	DDRA |= (1<<PA5); // SPI DO output
	DDRA |= (1<<PA4); // SPI CLK output
	DDRA &= ~(1<<PA6); // SPI DI input
	PORTA |= (1<<PA6); // SPI DI input
	DDRA |= (1<<spiCS); // SPI CS output
	
	// Set inputs
	DDRA &= ~(1<<usbminusPin);
	DDRA &= ~(1<<buttonPin);
	
	// Set outputs
	DDRA |= (1<<cpldresetPin);
	
	sei(); // Turn on interrupts
}

// Begin V-USB default required code
// Start USB communications
void startUSB(void) {
	usbDeviceDisconnect();
	_delay_ms(300); // 300 ms disconnect
	usbDeviceConnect();
	usbInit();
}
// End V-USB default required code
